import { ExpressMain } from '@teambit/express';
import { GraphqlMain } from '@teambit/graphql';
import { Logger } from '@teambit/logger';
import webpack from 'webpack';
import WebpackDevServer from 'webpack-dev-server';
import { UIRoot } from './ui-root';
import { UiMain } from './ui.main.runtime';
export declare type UIServerProps = {
    graphql: GraphqlMain;
    express: ExpressMain;
    ui: UiMain;
    uiRoot: UIRoot;
    uiRootExtension: string;
    logger: Logger;
};
export declare type StartOptions = {
    port?: number;
};
export declare class UIServer {
    private graphql;
    private expressExtension;
    private ui;
    private uiRoot;
    private uiRootExtension;
    private logger;
    constructor(graphql: GraphqlMain, expressExtension: ExpressMain, ui: UiMain, uiRoot: UIRoot, uiRootExtension: string, logger: Logger);
    private _port;
    get port(): number;
    getDevConfig(): Promise<webpack.Configuration>;
    start({ port }?: StartOptions): Promise<void>;
    private configureProxy;
    dev({ port }?: StartOptions): Promise<WebpackDevServer>;
    private selectPort;
    private getProxy;
    private getDevServerConfig;
    static create(props: UIServerProps): UIServer;
}
