import type { GraphqlUI } from '@teambit/graphql';
import { SlotRegistry } from '@teambit/harmony';
import type { ReactRouterUI } from '@teambit/react-router';
import React, { ReactNode } from 'react';
import { UIRootFactory } from './ui-root.ui';
declare type HudSlot = SlotRegistry<ReactNode>;
declare type ContextSlot = SlotRegistry<ContextType>;
export declare type UIRootRegistry = SlotRegistry<UIRootFactory>;
declare type ContextType = React.JSXElementConstructor<React.PropsWithChildren<any>>;
export declare class UiUI {
    private graphql;
    private router;
    private uiRootSlot;
    private hudSlot;
    private contextSlot;
    constructor(graphql: GraphqlUI, router: ReactRouterUI, uiRootSlot: UIRootRegistry, hudSlot: HudSlot, contextSlot: ContextSlot);
    render(rootExtension: string): void;
    registerHudItem: (element: React.ReactNode) => void;
    registerContext(context: ContextType): void;
    registerRoot(uiRoot: UIRootFactory): void;
    private getRoot;
    static slots: ((registerFn: () => string) => SlotRegistry<React.ReactNode>)[];
    static dependencies: import("@teambit/harmony").Aspect[];
    static runtime: import("@teambit/harmony").RuntimeDefinition;
    static provider([graphql, router]: [GraphqlUI, ReactRouterUI], config: any, [uiRootSlot, hudSlot, contextSlot]: [UIRootRegistry, HudSlot, ContextSlot]): Promise<UiUI>;
}
export {};
